Index: /trunk/src/org/expeditee/items/Picture.java
===================================================================
--- /trunk/src/org/expeditee/items/Picture.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/Picture.java	(revision 1102)
@@ -19,28 +19,7 @@
 package org.expeditee.items;
 
-import java.awt.AlphaComposite;
-import java.awt.BasicStroke;
-import java.awt.Color;
-import java.awt.Graphics2D;
-import java.awt.Image;
-import java.awt.Point;
-import java.awt.Polygon;
-import java.awt.Rectangle;
-import java.awt.Shape;
-import java.awt.Stroke;
-import java.awt.Toolkit;
-import java.awt.geom.AffineTransform;
-import java.awt.geom.Point2D;
-import java.awt.image.BufferedImage;
-import java.awt.image.CropImageFilter;
-import java.awt.image.FilteredImageSource;
-import java.awt.image.ImageObserver;
-import java.awt.image.PixelGrabber;
 import java.io.File;
 import java.io.IOException;
 import java.text.DecimalFormat;
-
-import javax.imageio.ImageIO;
-import javax.swing.ImageIcon;
 
 import org.apache.commons.cli.CommandLine;
@@ -49,11 +28,20 @@
 import org.apache.commons.cli.Options;
 import org.apache.commons.cli.ParseException;
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.core.Clip;
+import org.expeditee.core.Colour;
+import org.expeditee.core.Dimension;
+import org.expeditee.core.EnforcedClipStack.EnforcedClipKey;
+import org.expeditee.core.Image;
+import org.expeditee.core.Point;
+import org.expeditee.core.Stroke;
+import org.expeditee.core.bounds.AxisAlignedBoxBounds;
+import org.expeditee.core.bounds.CombinationBoxBounds;
+import org.expeditee.core.bounds.PolygonBounds;
+import org.expeditee.gio.EcosystemManager;
+import org.expeditee.gio.GraphicsManager;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.gui.FrameGraphics;
 import org.expeditee.gui.FrameIO;
-import org.expeditee.gui.FrameMouseActions;
 import org.expeditee.gui.FrameUtils;
-import org.expeditee.items.widgets.InteractiveWidget;
-import org.expeditee.stats.Logger;
 
 /**
@@ -75,4 +63,6 @@
  */
 public class Picture extends XRayable {
+	
+	private static final float CROPPING_COMPOSITE_ALPHA = 0.5f;
 
 	private static final int MINIMUM_WIDTH = 10;
@@ -114,10 +104,6 @@
 	private String _fileName = null;
 
-	// used to repaint animated GIF images, among other things.
-	protected ImageObserver _imageObserver = null;
-
-	protected Picture(Text source, ImageObserver observer, Image image) {
+	protected Picture(Text source, Image image) {
 		super(source);
-		_imageObserver = observer;
 		_image = image;
 
@@ -150,8 +136,7 @@
 	 *            screen.
 	 */
-	public Picture(Text source, String fileName, String path, String size,
-			ImageObserver observer) {
+	public Picture(Text source, String fileName, String path, String size)
+	{
 		super(source);
-		_imageObserver = observer;
 		_fileName = fileName;
 		_path = path;
@@ -226,9 +211,9 @@
 
 		// set the default values for start and end
-		_start.setLocation(0, 0);
+		_start.set(0, 0);
 		if (_image == null)
-			_end.setLocation(0, 0);
+			_end.set(0, 0);
 		else
-			_end.setLocation(_image.getWidth(null), _image.getHeight(null));
+			_end.set(_image.getWidth(), _image.getHeight());
 		size = size.trim();
 		String sizeLower = size.toLowerCase();
@@ -272,5 +257,5 @@
 		try {
 			if (size.length() == 0) {
-				size = "" + _image.getWidth(null);
+				size = "" + _image.getWidth();
 				_source.setText(getTagText() + size);
 				return;
@@ -293,8 +278,18 @@
 	}
 
+	public void setStartCrop(Point p)
+	{
+		if (p != null) setStartCrop(p.x, p.y);
+	}
+	
 	public void setStartCrop(int x, int y) {
 		invalidateCroppedArea();
 		_cropStart = new Point(x - getX(), y - getY());
 		invalidateCroppedArea();
+	}
+
+	public void setEndCrop(Point p)
+	{
+		if (p != null) setEndCrop(p.x, p.y);
 	}
 
@@ -312,6 +307,7 @@
 			int startY = getY() + topLeft.y - _highlightThickness;
 			int border = 2 * _highlightThickness;
-			invalidate(new Rectangle(startX, startY, bottomRight.x - topLeft.x
-					+ 2 * border, bottomRight.y - topLeft.y + 2 * border));
+			// TODO: Why invalidate specific area just before invalidateAll? cts16
+			invalidate(new AxisAlignedBoxBounds(startX, startY,
+					bottomRight.x - topLeft.x + 2 * border, bottomRight.y - topLeft.y + 2 * border));
 			invalidateAll();
 		} else {
@@ -325,7 +321,7 @@
 	}
 
-	public Point getBottomRightCrop() {
-		return new Point(Math.max(_cropStart.x, _cropEnd.x), Math.max(
-				_cropStart.y, _cropEnd.y));
+	public Point getBottomRightCrop()
+	{
+		return new Point(Math.max(_cropStart.x, _cropEnd.x), Math.max(_cropStart.y, _cropEnd.y));
 	}
 
@@ -335,8 +331,13 @@
 		invalidateCroppedArea();
 	}
-
-	public boolean isCropTooSmall() {
-		if (_cropStart == null || _cropEnd == null)
-			return true;
+	
+	public boolean isBeingCropped()
+	{
+		return (_cropStart != null && _cropEnd != null);
+	}
+
+	public boolean isCropTooSmall()
+	{
+		if (!isBeingCropped()) return true;
 
 		int cropWidth = Math.abs(_cropEnd.x - _cropStart.x);
@@ -353,5 +354,6 @@
 	}
 
-	public void updatePolygon() {
+	public PolygonBounds updateBounds()
+	{
 		if (_image == null) {
 			refresh();
@@ -360,5 +362,4 @@
 		
 		Point[] ori = new Point[4];
-		Point2D[] rot = new Point2D[4];
 		Point centre = new Point();
 
@@ -393,7 +394,7 @@
 			centre.y = base_y + (bottomRight.y - topLeft.y) / 2;
 			
-			Rectangle clip = new Rectangle(topLeft.x + base_x,
+			AxisAlignedBoxBounds clip = new AxisAlignedBoxBounds(topLeft.x + base_x,
 					topLeft.y + base_y, bottomRight.x - topLeft.x,
-					bottomRight.y - topLeft.y).getBounds();
+					bottomRight.y - topLeft.y);
 //			_poly.addPoint((int) clip.getMinX() - 1, (int) clip.getMinY() - 1);
 //			_poly.addPoint((int) clip.getMinX() - 1, (int) clip.getMaxY());
@@ -408,10 +409,11 @@
 		}
 		
-		AffineTransform.getRotateInstance(Math.PI * _rotate / 180, centre.x, centre.y).transform(ori, 0, rot, 0, 4);
-		
-		_poly = new Polygon();
-		for(Point2D p : rot) {
-			_poly.addPoint((int)p.getX(), (int)p.getY());
-		}
+		PolygonBounds poly = new PolygonBounds();
+		for (Point p : ori) {
+			poly.addPoint(p);
+		}
+		poly.rotate(Math.PI * _rotate / 180, centre);
+		
+		return poly.close();
 	}
 
@@ -454,23 +456,23 @@
 	 */
 	@Override
-	protected void paintLink(Graphics2D g) {
-		if (FrameGraphics.isAudienceMode())
-			return;
-		super.paintLink(g);
-	}
-	
-	public void paintImageTiling(Graphics2D g) {
-		if (_image == null) {
-			return;
-		}
-		
-		int iw = _image.getWidth(null);
-		int ih = _image.getHeight(null);
-		if(iw <= 0 || ih <= 0) {
-			return;
-		}
-		
-		int base_x = (_anchorLeft!=null) ? _anchorLeft : _source.getX();
-		int base_y = (_anchorTop!=null) ? _anchorTop : _source.getY();
+	protected void paintLink()
+	{
+		if (DisplayController.isAudienceMode()) return;
+		super.paintLink();
+	}
+	
+	/**
+	 * Paint the image repeatedly tiled over the drawing area.
+	 */
+	public void paintImageTiling()
+	{	
+		if (_image == null) return;
+		
+		int iw = _image.getWidth();
+		int ih = _image.getHeight();
+		if(iw <= 0 || ih <= 0) return;
+		
+		int base_x = (_anchorLeft != null) ? _anchorLeft : _source.getX();
+		int base_y = (_anchorTop != null) ? _anchorTop : _source.getY();
 		
 		int dX1 = base_x;
@@ -479,10 +481,9 @@
 		int dY2 = base_y + getHeight();
 		
-		BufferedImage tmp = new BufferedImage(getWidth(), getHeight(), BufferedImage.TYPE_INT_ARGB);
-		Graphics2D g2d = tmp.createGraphics();
+		Image tmp = Image.createImage(getWidth(), getHeight());
+		EcosystemManager.getGraphicsManager().pushDrawingSurface(tmp);
+
 		int offX = (tmp.getWidth() - getWidth()) / 2;
 		int offY = (tmp.getHeight() - getHeight()) / 2;
-		
-		// g2d.rotate(rotate, tmp.getWidth() / 2, tmp.getHeight() / 2);
 		
 		int cropStartX = _start.x;
@@ -491,4 +492,5 @@
     		cropEndX = iw;
     	}
+    	
 		for(int x = dX1; x < dX2; ) {
 			// end - start = (cropEnd - cropStart) * scale
@@ -506,4 +508,5 @@
         		cropEndY = ih;
         	}
+        	
 			for(int y = dY1; y < dY2; ) {
 				int h = (int) ((cropEndY - cropStartY) * _scale);
@@ -518,5 +521,12 @@
 				int sy = _flipY ? cropEndY : cropStartY;
 				int ey = _flipY ? cropStartY : cropEndY;
-				g2d.drawImage(_image, x - dX1 + offX, y - dY1 + offY, endX - dX1 + offX, endY - dY1 + offY, sx, sy, ex, ey, null);
+				
+				Point topLeft = new Point(x - dX1 + offX, y - dY1 + offY);
+				Dimension size = new Dimension(endX - x, endY - y);
+				Point cropTopLeft = new Point(sx, sy);
+				Dimension cropSize = new Dimension(ex - sx, ey - sy);
+				if (cropSize.width > 0 && cropSize.height > 0) {
+					EcosystemManager.getGraphicsManager().drawImage(_image, topLeft, size, 0.0, cropTopLeft, cropSize);
+				}
 				
 				cropStartY = 0;
@@ -531,84 +541,71 @@
 			x = endX;
 		}
-		
-		AffineTransform at = new AffineTransform();
-		at.translate(dX1, dY1);
-		at.rotate(Math.PI * _rotate / 180, tmp.getWidth() / 2, tmp.getHeight() / 2);
-		g.drawImage(tmp, at, _imageObserver);
-		// g.drawImage(tmp, dX1, dY1, dX2, dY2, 0, 0, tmp.getWidth(), tmp.getHeight(), _imageObserver);
-	}
-
-	@Override
-	public void paint(Graphics2D g) {
-		if (_image == null)
-			return;
-
-		paintLink(g);
-
-		// if we are showing the cropping, then show the original as transparent
+
+		EcosystemManager.getGraphicsManager().popDrawingSurface();
+		EcosystemManager.getGraphicsManager().drawImage(tmp, new Point(dX1, dY1), null, Math.PI * _rotate / 180);
+		tmp.releaseImage();
+	}
+
+	@Override
+	public void paint()
+	{
+		if (_image == null) return;
+
+		paintLink();
+		
+		GraphicsManager g = EcosystemManager.getGraphicsManager();
+
+		// if we are showing the cropping
 		if (_showCropping && !isCropTooSmall()) {
-			// show the full image as transparent
-			float alpha = .5f;
-			g.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER,
-					alpha));
-			
-			paintImageTiling(g);
-
-			g.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER,
-					1.0f));
+			// show the uncropped area as transparent
+			g.setCompositeAlpha(CROPPING_COMPOSITE_ALPHA);
+			paintImageTiling();
+			g.setCompositeAlpha(1.0f);
+			
 			// show the cropped area normally
 			Point topLeft = getTopLeftCrop();
 			Point bottomRight = getBottomRightCrop();
-			int base_x = (_anchorLeft!=null) ? _anchorLeft : _source.getX();
-			int base_y = (_anchorTop!=null) ? _anchorTop : _source.getY();
-			
-			Shape clip = new Rectangle(base_x + topLeft.x, base_y + topLeft.y,
-					bottomRight.x - topLeft.x, bottomRight.y - topLeft.y);
-			g.setColor(getPaintHighlightColor());
-			g.draw(clip);
-			g.setClip(clip);
-
-			paintImageTiling(g);
-			
-			g.draw(clip);
-			// if the image is cropped, but we are not showing the cropping
-			// otherwise, paint normally
+			int base_x = (_anchorLeft != null) ? _anchorLeft : _source.getX();
+			int base_y = (_anchorTop != null) ? _anchorTop : _source.getY();
+			
+			Clip clip = new Clip(new AxisAlignedBoxBounds(	base_x + topLeft.x,
+																	base_y + topLeft.y,
+																	bottomRight.x - topLeft.x,
+																	bottomRight.y - topLeft.y));
+			EnforcedClipKey key = g.pushClip(clip);
+			paintImageTiling();
+			g.popClip(key);
+
+			// Draw an outline for the crop selection box
+			g.drawRectangle(clip.getBounds(), 0.0, null, getPaintHighlightColor(), HIGHLIGHT_STROKE, null);
+
+		// otherwise, paint normally
 		} else {
-			paintImageTiling(g);
-		}
-
+			paintImageTiling();
+		}
+
+		PolygonBounds poly = (PolygonBounds) getBounds();
+		
 		if (hasVisibleBorder()) {
-			g.setColor(getPaintBorderColor());
-			Stroke borderStroke = new BasicStroke(getThickness(), CAP, JOIN);
-			g.setStroke(borderStroke);
-			g.drawPolygon(getPolygon());
+			Stroke borderStroke = new Stroke(getThickness(), DEFAULT_CAP, DEFAULT_JOIN);
+			g.drawPolygon(poly, null, null, 0.0, null, getPaintBorderColor(), borderStroke);
 		}
 
 		if (isHighlighted()) {
-			Stroke borderStroke = new BasicStroke(1, CAP, JOIN);
-			g.setStroke(borderStroke);
-			g.setColor(getHighlightColor());
-			g.drawPolygon(getPolygon());
-		}
-		
-		//System.out.print("p_");	
-	}
-
-	@Override
-	public Color getHighlightColor() {
-		if (_highlightColor.equals(getBorderColor()))
-			return ALTERNATE_HIGHLIGHT;
-		return _highlightColor;
-	}
-
-	@Override
-	public int setHighlightColor() {
-		super.setHighlightColor();
-
-		return Item.DEFAULT_CURSOR;
-	}
-
-	protected Picture createPicture() {
-		return ItemUtils.CreatePicture((Text) _source.copy(), _imageObserver);
+			Stroke borderStroke = new Stroke(1, DEFAULT_CAP, DEFAULT_JOIN);
+			g.drawPolygon(poly, null, null, 0.0, null, getHighlightColor(), borderStroke);
+		}
+	}
+
+	@Override
+	public Colour getHighlightColor()
+	{
+		if (_highlightColour.equals(getBorderColor())) return ALTERNATE_HIGHLIGHT;
+		return _highlightColour;
+	}
+
+	protected Picture createPicture()
+	{
+		return ItemUtils.CreatePicture((Text) _source.copy());
 	}
 
@@ -617,5 +614,5 @@
 		Picture p = createPicture();
 		p._image = _image;
-		p._mode = _mode;
+		p._highlightMode = _highlightMode;
 		// Doing Duplicate item duplicates link mark which we dont want to do
 		// when in audience mode because the linkMark will be copied incorrectly
@@ -632,6 +629,6 @@
 			int endX = Math.round(bottomRight.x / _scale + _start.x);
 			int endY = Math.round(bottomRight.y / _scale + _start.y);
-			int width = _image.getWidth(null);
-			int height = _image.getHeight(null);
+			int width = _image.getWidth();
+			int height = _image.getHeight();
 			// adjust our start and end if the user has dragged outside of the
 			// shape
@@ -663,5 +660,5 @@
 
 		p.updateSource();
-		p.updatePolygon();
+		p.invalidateBounds();
 
 		return p;
@@ -678,6 +675,6 @@
 	public void scaleCrop() {
 		// scale crop values to within image bounds
-		int iw = _image.getWidth(null);
-		int ih = _image.getHeight(null);
+		int iw = _image.getWidth();
+		int ih = _image.getHeight();
 		if(iw > 0 || ih > 0) {
 			while(_start.x >= iw) {
@@ -723,9 +720,8 @@
 			_scale = oldScale;
 		} else {
-			_source.translate(new Point2D.Float(FrameMouseActions.MouseX,
-					FrameMouseActions.MouseY), multiplier);
+			_source.translate(EcosystemManager.getInputManager().getCursorPosition(), multiplier);
 		}
 		updateSource();
-		updatePolygon();
+		invalidateBounds();
 		// Make sure items that are resized display the border
 		invalidateAll();
@@ -753,8 +749,5 @@
 		}
 		
-		return Toolkit.getDefaultToolkit().createImage(
-				new FilteredImageSource(_image.getSource(),
-						new CropImageFilter(_start.x, _start.y,
-								getUnscaledWidth(), getUnscaledHeight())));
+		return Image.createImageAsCroppedCopy(_image, _start.x, _start.y, getUnscaledWidth(), getUnscaledHeight());
 	}
 
@@ -771,5 +764,5 @@
 	 */
 	public boolean isCropped() {
-		return (_end.x != 0 && _end.x != _image.getWidth(null)) || (_end.y != 0 && _end.y != _image.getHeight(null)) || _start.y != 0 || _start.x != 0;
+		return (_end.x != 0 && _end.x != _image.getWidth()) || (_end.y != 0 && _end.y != _image.getHeight()) || _start.y != 0 || _start.x != 0;
 	}
 
@@ -779,4 +772,5 @@
 		// (notably.bmp) hence, we try this first, then if it fails we try
 		// ImageIO
+		/*
 		try {
 			_image = new ImageIcon(_path).getImage();
@@ -785,5 +779,5 @@
 
 		// if ImageIcon failed to read the image
-		if (_image == null || _image.getWidth(null) <= 0) {
+		if (_image == null || _image.getWidth() <= 0) {
 			try {
 				_image = ImageIO.read(new File(_path));
@@ -795,4 +789,6 @@
 			}
 		}
+*/
+		_image = Image.getImage(_path);
 		return true;
 	}
@@ -827,5 +823,5 @@
 	@Override
 	public boolean getLinkMark() {
-		return !FrameGraphics.isAudienceMode() && _source.getLinkMark();
+		return !DisplayController.isAudienceMode() && _source.getLinkMark();
 	}
 
@@ -892,6 +888,6 @@
 		// If the image is cropped add the position for the start and finish of
 		// the crop to the soure text
-		if (_start.x > 0 || _start.y > 0 || _end.x != _image.getWidth(null)
-				|| _end.y != _image.getHeight(null)) {
+		if (_start.x > 0 || _start.y > 0 || _end.x != _image.getWidth()
+				|| _end.y != _image.getHeight()) {
 			newText.append(" ").append(_start.x).append(" ").append(_start.y);
 			newText.append(" ").append(_end.x).append(" ").append(_end.y);
@@ -912,5 +908,5 @@
 
 	@Override
-	public void translate(Point2D origin, double ratio) {
+	public void translate(Point origin, double ratio) {
 		_scale *= ratio;
 		updateSource();
@@ -919,17 +915,14 @@
 
 	@Override
-	public Rectangle[] getDrawingArea() {
-
-		Rectangle[] da = super.getDrawingArea();
+	public AxisAlignedBoxBounds getDrawingArea() {
+
+		AxisAlignedBoxBounds da = super.getDrawingArea();
 
 		if (getLink() != null || hasAction()) {
-			Rectangle[] da2 = new Rectangle[da.length + 1];
-			System.arraycopy(da, 0, da2, 0, da.length);
-			da2[da.length] = getLinkPoly().getBounds();
-			da2[da.length].translate(getX() - LEFT_MARGIN, getY()
-					+ getLinkYOffset());
-			da2[da.length].width += 2;
-			da2[da.length].height += 2;
-			da = da2;
+			AxisAlignedBoxBounds linkBounds = AxisAlignedBoxBounds.getEnclosing(getLinkBounds());
+			linkBounds.getTopLeft().add(getX() - LEFT_MARGIN, getY() + getLinkYOffset());
+			linkBounds.getSize().width += 2;
+			linkBounds.getSize().height += 2;
+			da.combineWith(linkBounds);
 		}
 
@@ -963,5 +956,5 @@
 		_rotate = rotate;
 		updateSource();
-		updatePolygon();
+		invalidateBounds();
 	}
 	
@@ -970,8 +963,6 @@
 	}
 
-	public boolean MouseOverBackgroundPixel(int mouseX, int mouseY, Color bg_col)
-	{
-		int[] pixels = new int[1];
-		 
+	public boolean MouseOverBackgroundPixel(int mouseX, int mouseY, Colour bg_col)
+	{
 		int base_x = (_anchorLeft!=null) ? _anchorLeft : _source.getX();
 		int base_y = (_anchorTop!=null) ? _anchorTop : _source.getY();
@@ -979,31 +970,13 @@
 		int y = mouseY - base_y;
 		
-		// Consider making this a slightly larger area to check, say 3 x 3?
-		// Back op if all are the same sought after color?
-		PixelGrabber grabber = new PixelGrabber(_image, x,y, 1, 1, pixels, 0, 1);
-		
-		// The following might be a better approach, as it sets the color model
-		// when getPixels() is called, however, it might return an int[] or byte[]
-		// array (handled as Object), as so some extra complexity would exist in
-		// handling the returned result
-		
-		//PixelGrabber pg = new PixelGrabber(_image, mouseX, mouseY, 1, 1, true);
-		
-		try {
-			grabber.grabPixels(0);
-		} 
-		catch (Exception e) {
-			e.printStackTrace();
-		}
-		
-	
-		int c = pixels[0];
-		int c_red    = (c & 0x00ff0000) >> 16;
-		int c_green  = (c & 0x0000ff00) >> 8;
-		int c_blue   =  c & 0x000000ff;
-		
-		int bg_red   = (bg_col!=null) ? bg_col.getRed()   : 0xff;
-		int bg_green = (bg_col!=null) ? bg_col.getGreen() : 0xff;
-		int bg_blue  = (bg_col!=null) ? bg_col.getBlue()  : 0xff;
+		Colour c = _image.getPixel(x, y);
+
+		int c_red    = c.getRed255();
+		int c_green  = c.getGreen255();
+		int c_blue   = c.getBlue255();
+		
+		int bg_red   = (bg_col!=null) ? bg_col.getRed255()   : 0xff;
+		int bg_green = (bg_col!=null) ? bg_col.getGreen255() : 0xff;
+		int bg_blue  = (bg_col!=null) ? bg_col.getBlue255()  : 0xff;
 		
 		int red_diff   = Math.abs(c_red   - bg_red);
Index: /trunk/src/org/expeditee/items/Tooltip.java
===================================================================
--- /trunk/src/org/expeditee/items/Tooltip.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/Tooltip.java	(revision 1102)
@@ -9,48 +9,77 @@
 import org.expeditee.settings.templates.TemplateSettings;
 
+/**
+ * TODO: Comment. cts16
+ * 
+ * @author cts16
+ */
 public class Tooltip {
+
+	/** TODO: Comment. cts16 */
+	private Map<Text, Item> _tooltipItems = new HashMap<Text, Item>();
 	
-	Tooltip() { }
-	
-	private Map<Text, Item> tooltipItems = new HashMap<Text, Item>();
-	
-	public Text addTooltip(String content, final Item toItem) {
-		if(content.trim().toLowerCase().startsWith("text") && content.contains(":")) 
+	/** TODO: Comment. cts16 */
+	Tooltip()
+	{
+	}
+
+	/** TODO: Comment. cts16 */
+	public Text addTooltip(String content, final Item toItem)
+	{
+		if(content.trim().toLowerCase().startsWith("text") && content.contains(":")) {
 			content = content.substring(content.indexOf(':') + 1);
+		}
 		final Text tooltip = TemplateSettings.TooltipTemplate.get().copy();
+		tooltip.setWidth(Integer.MAX_VALUE); // Tooltip shouldn't be width-limited
 		tooltip.setText(content);
 		return addTooltip(tooltip, toItem);
 	}
-	
-	public Text addTooltip(final Text tooltip, final Item toItem) {
-		tooltipItems.put(tooltip, toItem);
+
+	/** TODO: Comment. cts16 */
+	public Text addTooltip(final Text tooltip, final Item toItem)
+	{
+		_tooltipItems.put(tooltip, toItem);
 		return tooltip;
 	}
-	
-	public Collection<Text> getTooltips() { return tooltipItems.keySet(); }
-	
-	public List<String> asStringList() { 
+
+	/** TODO: Comment. cts16 */
+	public Collection<Text> getTooltips()
+	{
+		return _tooltipItems.keySet();
+	}
+
+	/** TODO: Comment. cts16 */
+	public List<String> asStringList()
+	{ 
 		final List<String> ret = new LinkedList<String>();
-		for(final Text tooltip: tooltipItems.keySet()) ret.add(tooltip.getText());
+		for(final Text tooltip: _tooltipItems.keySet()) ret.add(tooltip.getText());
 		return ret;
 	}
-	
-	public int getWidth() {
+
+	/** TODO: Comment. cts16 */
+	public int getWidth()
+	{
 		int max = 0;
-		for(final Text tooltip: tooltipItems.keySet()) 
+		for(final Text tooltip: _tooltipItems.keySet()) {
 			if(tooltip.getBoundsWidth() > max) max = tooltip.getBoundsWidth();
+		}
 		return max;
 	}
 
-	public int getHeight() {
+	/** TODO: Comment. cts16 */
+	public int getHeight()
+	{
 		int max = 0;
-		for(final Text tooltip: tooltipItems.keySet()) 
+		for(final Text tooltip: _tooltipItems.keySet()) {
 			if(tooltip.getBoundsWidth() > max) max = tooltip.getBoundsHeight();
+		}
 		return max;
 	}
-	
-	public int getCollectiveHeight() {
+
+	/** TODO: Comment. cts16 */
+	public int getCollectiveHeight()
+	{
 		int height = 0;
-		for(final Text tooltip: tooltipItems.keySet()) height += tooltip.getBoundsHeight();
+		for(final Text tooltip: _tooltipItems.keySet()) height += tooltip.getBoundsHeight();
 		return height;
 	}
Index: /trunk/src/org/expeditee/items/XRayable.java
===================================================================
--- /trunk/src/org/expeditee/items/XRayable.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/XRayable.java	(revision 1102)
@@ -19,10 +19,11 @@
 package org.expeditee.items;
 
-import java.awt.Color;
-import java.awt.geom.Point2D;
 import java.util.Collection;
 import java.util.LinkedList;
 import java.util.List;
 
+import org.expeditee.core.Colour;
+import org.expeditee.core.Point;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.gui.FrameGraphics;
 
@@ -101,10 +102,10 @@
 	
 	@Override
-	public Color getColor() {
+	public Colour getColor() {
 		return _source.getColor();
 	}
 
 	@Override
-	public void setColor(Color c) {
+	public void setColor(Colour c) {
 		_source.setColor(c);
 		invalidateCommonTrait(ItemAppearence.ForegroundColorChanged);
@@ -112,15 +113,15 @@
 	
 	@Override
-	public void setBackgroundColor(Color c) {
+	public void setBackgroundColor(Colour c) {
 		_source.setBackgroundColor(c);
 	}
 	
 	@Override
-	public void setFillColor(Color c) {
+	public void setFillColor(Colour c) {
 		_source.setFillColor(c);
 	}
 	
 	@Override
-	public void setBorderColor(Color c) {
+	public void setBorderColor(Colour c) {
 		_source.setBorderColor(c);
 		invalidateCommonTrait(ItemAppearence.BorderColorChanged);
@@ -128,5 +129,5 @@
 	
 	@Override
-	public void setGradientColor(Color c) {
+	public void setGradientColor(Colour c) {
 		_source.setGradientColor(c);
 	}
@@ -153,20 +154,20 @@
 	
 	@Override
-	public Float getAnchorLeft() {
+	public Integer getAnchorLeft() {
 	        return _source.getAnchorLeft();
 	}
 	
 	@Override
-	public Float getAnchorRight() {
+	public Integer getAnchorRight() {
 		return _source.getAnchorRight();
 	}
 
 	@Override
-	public Float getAnchorTop() {
+	public Integer getAnchorTop() {
 		return _source.getAnchorTop();
 	}
 
 	@Override
-	public Float getAnchorBottom() {
+	public Integer getAnchorBottom() {
 		return _source.getAnchorBottom();
 	}
@@ -174,5 +175,5 @@
 	
 	@Override
-	public Color getBorderColor() {
+	public Colour getBorderColor() {
 		return _source.getBorderColor();
 	}
@@ -186,15 +187,15 @@
 	
 	@Override
-	public Color getBackgroundColor() {
+	public Colour getBackgroundColor() {
 		return _source.getBackgroundColor();
 	}
 	
 	@Override
-	public Color getFillColor() {
+	public Colour getFillColor() {
 		return _source.getFillColor();
 	}
 	
 	@Override
-	public Color getGradientColor() {
+	public Colour getGradientColor() {
 		return _source.getGradientColor();
 	}
@@ -226,5 +227,5 @@
 			invalidateAll();
 		_source.setLink(frameName);
-		updatePolygon();
+		invalidateBounds();
 		//TODO: only invalidate the link bit
 		invalidateAll();
@@ -239,5 +240,5 @@
 			invalidateAll();
 		_source.setActions(action);
-		updatePolygon();
+		invalidateBounds();
 		invalidateAll();
 	}
@@ -252,7 +253,7 @@
 	
 	@Override
-	public void translate(Point2D origin, double ratio){
+	public void translate(Point origin, double ratio){
 		//_source.translate(origin, ratio);
-		updatePolygon();
+		invalidateBounds();
 	}
 	
@@ -279,5 +280,5 @@
 
 	@Override
-	public void setAnchorTop(Float anchor) {
+	public void setAnchorTop(Integer anchor) {
 		_source.setAnchorTop(anchor);
 		if (anchor != null)
@@ -286,20 +287,20 @@
 
 	@Override
-	public void setAnchorBottom(Float anchor) {
+	public void setAnchorBottom(Integer anchor) {
 		_source.setAnchorBottom(anchor);
 		if (anchor != null)
-			_source.setY(FrameGraphics.getMaxFrameSize().height - getHeight() - anchor);
-	}
-
-	
-	@Override
-	public void setAnchorLeft(Float anchor) {
+			_source.setY(DisplayController.getFramePaintArea().getHeight() - getHeight() - anchor);
+	}
+
+	
+	@Override
+	public void setAnchorLeft(Integer anchor) {
 		_source.setAnchorLeft(anchor);
 	}
 
 	@Override
-	public void setAnchorRight(Float anchor) {
+	public void setAnchorRight(Integer anchor) {
 		_source.setAnchorRight(anchor);
-		_source.setX(FrameGraphics.getMaxFrameSize().width - anchor - this.getWidth());
+		_source.setX(DisplayController.getFramePaintArea().getWidth() - anchor - this.getWidth());
 	}
 	
Index: /trunk/src/org/expeditee/items/widgets/ButtonWidget.java
===================================================================
--- /trunk/src/org/expeditee/items/widgets/ButtonWidget.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/widgets/ButtonWidget.java	(revision 1102)
@@ -1,5 +1,4 @@
 package org.expeditee.items.widgets;
 import java.awt.BorderLayout;
-import java.awt.Color;
 import java.awt.Dimension;
 import java.net.URL;
@@ -9,4 +8,6 @@
 import javax.swing.border.EmptyBorder;
 
+import org.expeditee.core.Colour;
+import org.expeditee.gio.swing.SwingConversions;
 import org.expeditee.items.Text;
 
@@ -14,9 +15,9 @@
 
 //Will be the default class for Rubbish Bin, Reset and Undo Button Widgets
-public class ButtonWidget extends InteractiveWidget{
-
+public class ButtonWidget extends SwingWidget
+{
 	protected JButton clicked_ = new JButton("");	
 	protected SVGIcon icon_ = null;
-	
+
 	public ButtonWidget(int dimension, String filePath, Text source, String[] args)
 	{
@@ -25,12 +26,13 @@
 				
 		clicked_.setBorder(new EmptyBorder(0, 0, 0, 0));
-		clicked_.setBackground(Color.white);
+		clicked_.setBackground(SwingConversions.toSwingColor(Colour.WHITE));
 		
 		Dimension size = new Dimension(dimension, dimension);
 		icon_ = new SVGIcon();
-		try{
+		
+		try {
 			URL imageURL = ClassLoader.getSystemResource(filePath);		
 			icon_.setSvgURI(imageURL.toURI());
-			//This STILL works, unsure why. Don't remove it has an affect on the button appearance.		
+			// This STILL works, unsure why. Don't remove it has an affect on the button appearance.
 			icon_.setUseAntiAlias(true);
 			icon_.setScaleToFit(true);
@@ -39,8 +41,6 @@
 			_swingComponent.add(clicked_);
 			this.setWidgetEdgeThickness(0.0f);
-			this.setWidgetEdgeColor(Color.white);	
-		}
-		catch(Exception e){
-			
+			this.setWidgetEdgeColor(Colour.WHITE);	
+		} catch(Exception e) {
 			//Set a default image if image is missing
 			System.out.println("Unable to load image from directory");			
@@ -49,18 +49,24 @@
 
 	@Override
-	protected String[] getArgs() {
+	protected String[] getArgs()
+	{
 		// TODO Auto-generated method stub
 		return null;
 	}
-	public boolean itemHeldWhileClicked(InteractiveWidget bw) {
+	
+	public boolean itemHeldWhileClicked(Widget bw)
+	{
 		// TODO Auto-generated method stub
 		return false;
 	}
-	public boolean getdropInteractableStatus(){
+	
+	public boolean getdropInteractableStatus()
+	{
 		return false;
 	}
 
 	@Override
-	boolean setPositions(WidgetCorner src, float x, float y) {
+	public boolean setPositions(WidgetCorner src, float x, float y)
+	{
 		boolean result = super.setPositions(src, x, y);
 
Index: /trunk/src/org/expeditee/items/widgets/DataFrameWidget.java
===================================================================
--- /trunk/src/org/expeditee/items/widgets/DataFrameWidget.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/widgets/DataFrameWidget.java	(revision 1102)
@@ -19,6 +19,4 @@
 package org.expeditee.items.widgets;
 
-import java.awt.Color;
-import java.awt.Graphics;
 import java.util.Collection;
 import java.util.HashSet;
@@ -26,5 +24,9 @@
 import javax.swing.JComponent;
 
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.core.Colour;
+import org.expeditee.core.Point;
+import org.expeditee.gio.EcosystemManager;
+import org.expeditee.gio.GraphicsManager;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.gui.Frame;
 import org.expeditee.gui.FrameIO;
@@ -34,5 +36,5 @@
 import org.expeditee.items.Text;
 
-public abstract class DataFrameWidget extends InteractiveWidget implements
+public abstract class DataFrameWidget extends SwingWidget implements
 		FrameObserver {
 
@@ -118,5 +120,5 @@
 	public void update() {
 		Frame parent = getParentFrame();
-		if (parent != null && parent == DisplayIO.getCurrentFrame()) {
+		if (parent != null && parent == DisplayController.getCurrentFrame()) {
 			refresh();
 		}
@@ -166,9 +168,9 @@
 	}
 
-	protected void paintInFreeSpace(Graphics g) {
-		super.paintInFreeSpace(g);
-		g.setFont(((Text) getSource()).getFont());
-		g.setColor(Color.WHITE);
-		g.drawString(this.getClass().getSimpleName(), getX() + 10, getY() + 20);
+	protected void paintInFreeSpace()
+	{
+		super.paintInFreeSpace();
+		GraphicsManager g = EcosystemManager.getGraphicsManager();
+		g.drawString(this.getClass().getSimpleName(), new Point(getX() + 10, getY() + 20), ((Text) getSource()).getFont(), Colour.WHITE);
 
 	}
